<?php
/***************************************************************************
 *                           admin/admin_ecard_ec.php
 *                          ------------------------------
 *   Version              : Version 0.2.0 - 09.01.2006
 *   copyright            : (C) 2005-2006 M.W.
 *   URL                  : http://phpbb.mwegner.de/
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['eCard']['ec_eCards'] = $filename;
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_ecard.' . $phpEx);
include($phpbb_root_path . 'includes/ecard_config.'.$phpEx);

if ($ecard_config['ec_delete'] === TRUE)
{
	$sql = "DELETE FROM " . ECARD_TABLE . "
		WHERE date < " . (time() - $ecard_config['max_age']);
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not update ecard table', __LINE__, __FILE__, $sql);
	}
}

$template->set_filenames(array(
	'body' => ADM_TPL . 'ecard_ec_body.tpl')
);

$sql = "SELECT e.id, e.user_id, e.date, e.image_id, e.to_name, e.to_email, e.readed, u.username, i.title 
	FROM
	" . ECARD_TABLE . " e LEFT JOIN " . ECARD_IMAGES_TABLE . " i ON e.image_id=i.image_id, 
	" . USERS_TABLE . " u
	WHERE e.user_id = u.user_id 
	ORDER BY e.date DESC, e.to_email ASC";

if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not query eCard information', '', __LINE__, __FILE__, $sql);
}
while ($row = $db->sql_fetchrow($result))
{
	$ecrow[] = $row;
}

$ec_max_age_ber = $ecard_config['max_age'];
$ec_max_age = '';
if (floor($ec_max_age_ber / 31622400) > 1)
{
	$ec_max_age .= floor($ec_max_age_ber / 31622400) . ' ' . $lang_ec['Years'] . ' ';
	$ec_max_age_ber = $ec_max_age_ber - (floor($ec_max_age_ber / 31622400) * 31622400);
}
elseif (floor($ec_max_age_ber / 31622400) == 1)
{
	$ec_max_age .= floor($ec_max_age_ber / 31622400) . ' ' . $lang_ec['Year'] . ' ';
	$ec_max_age_ber = $ec_max_age_ber - 31622400;
}
if ($ec_max_age_ber > 0)
{
	if (floor($ec_max_age_ber / 2635200) > 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 2635200) . ' ' . $lang_ec['Months'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - (floor($ec_max_age_ber / 2635200) * 2635200);
	}
	elseif (floor($ec_max_age_ber / 2635200) == 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 2635200) . ' ' . $lang_ec['Month'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - 2635200;
	}
}
if ($ec_max_age_ber > 0)
{
	if (floor($ec_max_age_ber / 86400) > 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 86400) . ' ' . $lang_ec['Days'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - (floor($ec_max_age_ber / 86400) * 86400);
	}
	elseif (floor($ec_max_age_ber / 86400) == 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 86400) . ' ' . $lang_ec['Day'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - 86400;
	}
}
if ($ec_max_age_ber > 0)
{
	if (floor($ec_max_age_ber / 3600) > 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 3600) . ' ' . $lang_ec['Hours'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - (floor($ec_max_age_ber / 3600) * 3600);
	}
	elseif (floor($ec_max_age_ber / 3600) == 1)
	{
		$ec_max_age .= floor($ec_max_age_ber / 3600) . ' ' . $lang_ec['Hour'] . ' ';
		$ec_max_age_ber = $ec_max_age_ber - 3600;
	}
}
if ($ec_max_age_ber > 0)
{
	$ec_max_age_ber = ceil($ec_max_age_ber / 60);
	if ($ec_max_age_ber > 1)
	{
		$ec_max_age .= $ec_max_age_ber . ' ' . $lang_ec['Minutes'];
	}
	elseif ($ec_max_age_ber == 1)
	{
		$ec_max_age .= $ec_max_age_ber . ' ' . $lang_ec['Minute'];
	}
}
$ec_max_age = trim($ec_max_age);

$template->assign_vars(array(
	'L_ECARD_EC_TITLE' => $lang_ec['Admin_eCard_Title'],
	'L_ECARD_EC_EXPLAIN' => sprintf($lang_ec['Admin_eCard_Explain'], $ec_max_age),
	'L_TO' => $lang_ec['ECard_to'],
	'L_FROM' => $lang_ec['ECard_from'],
	'L_IMAGE' => $lang_ec['Image'],
	'L_SDATE' => $lang_ec['Send_date'],
	'L_STATUS' => $lang_ec['Status'],
	'S_ECARD_VERSION' => $ecard_config['version'])
);


$ec_count = count($ecrow);
if ($ec_count > 0)
{
	for ($i=0; $i<$ec_count; $i++)
	{
		if ($ecard_config['ec_show'] === TRUE)
		{
			$template->assign_block_vars('ecrow', array(
				'COLOR' => ($i % 2) ? 'row1' : 'row2',
				'EC_ID' => $ecrow[$i]['id'],
				'VON_NAME' => $ecrow[$i]['username'],
				'AN_NAME' => $ecrow[$i]['to_name'],
				'IMAGE' => ($ecrow[$i]['title'] == '') ? '&gt;&gt;'.$lang_ec['no_image'].'&lt;&lt;' : $ecrow[$i]['title'],
				'GELESEN' => ($ecrow[$i]['readed'] == 1) ? 'gelesen' : '<b>ungelesen</b>',
				'DATE' => date("d.m.Y H:i", $ecrow[$i]['date']),
				'U_VIEWPROFILE' => append_sid("../profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $ecrow[$i]['user_id']),
				'U_IMAGEEDIT' => append_sid("admin_ecard_img.$phpEx?action=edit&amp;iid=" . $ecrow[$i]['image_id']),
				'CLASS1' => '<a href="' . append_sid("../ecard.$phpEx?eid=" . $ecrow[$i]['id']) . '&amp;x=x" class="gen">',
				'CLASS2' => '</a>',
				'AN_EMAIL1' => '<a href="mailto:' . $ecrow[$i]['to_email'] . '" title="' . $ecrow[$i]['to_name'] . '" class="genmed">',
				'AN_EMAIL2' => '</a>')
			);
		}
		else
		{
			$template->assign_block_vars('ecrow', array(
				'COLOR' => ($i % 2) ? 'row1' : 'row2',
				'VON_NAME' => $ecrow[$i]['username'],
				'AN_NAME' => $ecrow[$i]['to_name'],
				'CLASS1' => '<span class="gen">',
				'CLASS2' => '</span>',
				'AN_EMAIL1' => '<span class="genmed">',
				'AN_EMAIL2' => '</span>',
				'IMAGE' => $ecrow[$i]['title'],
				'GELESEN' => ($ecrow[$i]['readed'] == 1) ? 'gelesen' : '<b>ungelesen</b>',
				'DATE' => date("d.m.Y H:i", $ecrow[$i]['date']),
				'U_VIEWPROFILE' => append_sid("../profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $ecrow[$i]['user_id']),
				'U_IMAGEEDIT' => append_sid("admin_ecard_img.$phpEx?action=edit&amp;iid=" . $ecrow[$i]['image_id']))
			);
		}
	}
}
else
{
	$template->assign_block_vars('switch_no_ecards', array()); 
	$template->assign_vars(array(
		'L_NO_ECARDS' => $lang_ec['no_ecards'])
	);
}



$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>