<?php
/***************************************************************************
 *                           admin/admin_ecard_img.php
 *                          ------------------------------
 *   Version              : Version 0.2.0 - 09.01.2006
 *   copyright            : (C) 2005-2006 M.W.
 *   URL                  : http://phpbb.mwegner.de/
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['eCard']['ec_Images'] = $filename;
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_ecard.' . $phpEx);
include($phpbb_root_path . 'includes/ecard_config.'.$phpEx);

if (!isset($HTTP_POST_VARS['mode']))
{
	if (!isset($HTTP_GET_VARS['action']))
	{
		$template->set_filenames(array(
			'body' => ADM_TPL . 'ecard_img_body.tpl')
		);

		$template->assign_vars(array(
			'L_ECARD_IMG_TITLE' => $lang_ec['Admin_Images_Title'],
			'L_ECARD_IMG_EXPLAIN' => $lang_ec['Admin_Images_Explain'],
			'L_SHOW_IMAGES' => $lang_ec['Admin_show_Images'],
			'S_ECARD_VERSION' => $ecard_config['version'])
		);

		$eccatrow[0]['id'] = 0;
		$eccatrow[0]['categorie'] = $lang_ec['Main_Categorie'];
		$sql = "SELECT *
			FROM " . ECARD_CATEGORIES_TABLE . "
			ORDER BY categorie ASC";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
		}
		while ($row = $db->sql_fetchrow($result))
		{
			$eccatrow[] = $row;
		}

		$eccat_count = count($eccatrow);
		for ($i=0; $i<$eccat_count; $i++)
		{
			$template->assign_block_vars('eccatrow', array(
				'COLOR' => ($i % 2) ? 'row1' : 'row2',
				'TITLE' => $eccatrow[$i]['categorie'],
				'U_IMG_ACTION' => append_sid("admin_ecard_img.$phpEx?action=view&amp;cid=" . $eccatrow[$i]['id']))
			);
		}

		$template->pparse('body');

		include('./page_footer_admin.'.$phpEx);
	}
	else
	{
		if ($HTTP_GET_VARS['action'] == 'view')
		{
			$template->set_filenames(array(
				'body' => ADM_TPL . 'ecard_img_list.tpl')
			);

			$eccatid = intval($HTTP_GET_VARS['cid']);
			if ($eccatid != 0)
			{
				$sql = "SELECT *
					FROM " . ECARD_CATEGORIES_TABLE . "
					WHERE id = " . $eccatid;
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
				}
				if( $db->sql_numrows($result) == 0 )
				{
					message_die(GENERAL_ERROR, 'The requested category does not exist');
				}
				$eccatrow = $db->sql_fetchrow($result);
			}
			else
			{
				$eccatrow['id'] = 0;
				$eccatrow['categorie'] = $lang_ec['Main_Categorie'];
			}

			$template->assign_vars(array(
				'L_ECARD_IMG_TITLE' => $lang_ec['Admin_Images_Title'],
				'L_ECARD_IMG_EXPLAIN' => $lang_ec['Admin_Images_Explain'],
				'L_SHOW_IMAGES' => $lang_ec['Admin_show_Images'],
				'L_IMAGE' => $lang_ec['Image'],
				'L_UPLOAD' => $lang_ec['Upload_date'],
				'L_COUNTER' => $lang_ec['Counter'],
				'L_COUNTER_EXPLAIN' => $lang_ec['Counter_Explain'],
				'L_EDIT' => $lang['Edit'],
				'L_DELETE' => $lang['Delete'],
				'S_CAT_TITLE' => $eccatrow['categorie'],
				'S_ECARD_VERSION' => $ecard_config['version'])
			);

			$sql = "SELECT image_id, title, thumbnail, counter, time 
				FROM " . ECARD_IMAGES_TABLE . "
				WHERE categorie_id = " . $eccatid . "
				ORDER BY title ASC";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Images information', '', __LINE__, __FILE__, $sql);
			}

			while ($row = $db->sql_fetchrow($result))
			{
				$imgrow[] = $row;
			}

			$imgrow_count = count($imgrow);
			if ($imgrow_count > 0)
			{
				for ($i=0; $i<$imgrow_count; $i++)
				{
					$template->assign_block_vars('ecimgrow', array(
						'COLOR' => ($i % 2) ? 'row1' : 'row2',
						'TITLE' => $imgrow[$i]['title'],
						'THUMBNAIL' => $phpbb_root_path . 'images/ecard/gallery/' . $imgrow[$i]['thumbnail'],
						'COUNTER' => $imgrow[$i]['counter'],
						'TIME' => date("d.m.Y H:i", $imgrow[$i]['time']),
						'U_IMG_EDIT' => append_sid("admin_ecard_img.$phpEx?action=edit&amp;iid=" . $imgrow[$i]['image_id']),
						'U_IMG_DELETE' => append_sid("admin_ecard_img.$phpEx?action=delete&amp;iid=" . $imgrow[$i]['image_id']))
					);
				}
			}
			else
			{
				$template->assign_block_vars('switch_no_images', array()); 
				$template->assign_vars(array(
					'L_NO_IMAGES' => $lang_ec['no_cat_images'])
				);
			}

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		elseif ($HTTP_GET_VARS['action'] == 'edit')
		{
			$ecimgid = intval($HTTP_GET_VARS['iid']);
			$sql = "SELECT image_id, title, thumbnail, categorie_id, counter, time 
				FROM " . ECARD_IMAGES_TABLE . "
				WHERE image_id = " . $ecimgid;
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Image information', '', __LINE__, __FILE__, $sql);
			}
			if( $db->sql_numrows($result) == 0 )
			{
				message_die(GENERAL_ERROR, 'The requested image does not exist');
			}
			$ecimgrow = $db->sql_fetchrow($result);

			$eccatrow[0]['id'] = 0;
			$eccatrow[0]['categorie'] = $lang_ec['Main_Categorie'];
			$sql = "SELECT *
				FROM " . ECARD_CATEGORIES_TABLE . "
				ORDER BY categorie ASC";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
			}
			while ($row = $db->sql_fetchrow($result))
			{
				$eccatrow[] = $row;
			}
			$eccatrow_count = count($eccatrow);
			$select_to = '<select name="target">';
			for ($i=0; $i<$eccatrow_count; $i++)
			{
				$select_to .= '<option value="' . $eccatrow[$i]['id'] . '"';
				if ($eccatrow[$i]['id'] == $ecimgrow['categorie_id'])
				{
					$select_to .= ' selected="selected"';
				}
				$select_to .= '>' . $eccatrow[$i]['categorie'] . '</option>';
			}
			$select_to .= '</select>';

			$template->set_filenames(array(
				'body' => ADM_TPL . 'ecard_img_edit_body.tpl')
			);

			$template->assign_vars(array(
				'L_ECARD_IMG_TITLE' => $lang_ec['Admin_Images_Title'],
				'L_ECARD_IMG_EXPLAIN' => $lang_ec['Admin_Images_Explain'],
				'L_PANEL_TITLE' => $lang_ec['Edit_Image'],
				'L_CATEGORIE' => $lang_ec['Categorie'],
				'L_IMG_TITLE' => $lang_ec['Image_Title'],
				'L_UPLOAD' => $lang_ec['Upload_date'],
				'L_COUNTER' => $lang_ec['Counter'],
				'L_COUNTER_EXPLAIN' => $lang_ec['Counter_Explain'],
				'S_CATEGORIE' => $select_to,
				'S_THUMBNAIL' => $phpbb_root_path . 'images/ecard/gallery/' . $ecimgrow['thumbnail'],
				'S_TITLE' => $ecimgrow['title'],
				'S_COUNTER' => $ecimgrow['counter'],
				'S_TIME' => date("d.m.Y H:i", $ecimgrow['time']),
				'S_ECARD_VERSION' => $ecard_config['version'],
				'U_ECARD_ACTION' => append_sid("admin_ecard_img.$phpEx?iid=$ecimgid"))
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		elseif ($HTTP_GET_VARS['action'] == 'delete')
		{
			$ecdelimgid = intval($HTTP_GET_VARS['iid']);

			$sql = "SELECT image_id, title, thumbnail, categorie_id, counter, time 
				FROM " . ECARD_IMAGES_TABLE . "
				WHERE image_id = " . $ecdelimgid;
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Image information', '', __LINE__, __FILE__, $sql);
			}
			if( $db->sql_numrows($result) == 0 )
			{
				message_die(GENERAL_ERROR, 'The requested image does not exist');
			}
			$ecimgrow = $db->sql_fetchrow($result);

			if ($ecimgrow['categorie_id'] != 0)
			{
				$sql = "SELECT * 
					FROM " . ECARD_CATEGORIES_TABLE . "
					WHERE id = " . $ecimgrow['categorie_id'];
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not query eCard category information', '', __LINE__, __FILE__, $sql);
				}
				if( $db->sql_numrows($result) == 0 )
				{
					message_die(GENERAL_ERROR, 'The requested category does not exist');
				}
				$eccatrow = $db->sql_fetchrow($result);
			}
			else
			{
				$eccatrow['id'] = 0;
				$eccatrow['categorie'] = $lang_ec['Main_Categorie'];
			}

			$ecNRrow = array();
			$sql = "SELECT *
				FROM " . ECARD_TABLE . "
				WHERE image_id = " . $ecdelimgid . "
				AND readed = '0'";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard information', '', __LINE__, __FILE__, $sql);
			}
			while ($row = $db->sql_fetchrow($result))
			{
				$ecNRrow[] = $row;
			}
			$ecNRcount = count($ecNRrow);

			$ecARrow = array();
			$sql = "SELECT *
				FROM " . ECARD_TABLE . "
				WHERE image_id = " . $ecdelimgid . "
				AND readed = '1'";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard information', '', __LINE__, __FILE__, $sql);
			}
			while ($row = $db->sql_fetchrow($result))
			{
				$ecARrow[] = $row;
			}
			$ecARcount = count($ecARrow);

			$template->set_filenames(array(
				'body' => ADM_TPL . 'ecard_img_delete_body.tpl')
			);

			$ec_ec_nr = $lang_ec['images_eCards_nr'];
			if ($ecNRcount > 0)
			{
				$ecNRcount = '<b>' . $ecNRcount . '</b>';
				$ec_ec_nr = '<b>' . $ec_ec_nr . '</b>';
			}

			$template->assign_vars(array(
				'L_IMG_DELETE' => $lang_ec['Delete_Image'],
				'L_IMG_DELETE_EXPLAIN' => $lang_ec['Delete_Image_Explain'],
				'L_PANEL_TITLE' => $lang_ec['Delete_Image'],
				'L_CATEGORIE' => $lang_ec['Categorie'],
				'L_IMG_TITLE' => $lang_ec['Image_Title'],
				'L_UPLOAD' => $lang_ec['Upload_date'],
				'L_COUNTER' => $lang_ec['Counter'],
				'L_COUNTER_EXPLAIN' => $lang_ec['Counter_Explain'],
				'L_ECARDS_NR' => $ec_ec_nr,
				'L_ECARDS_AR' => $lang_ec['images_eCards_ar'],
				'L_DELETE' => $lang['Delete'],
				'S_CATEGORIE' => $eccatrow['categorie'],
				'S_THUMBNAIL' => $phpbb_root_path . 'images/ecard/gallery/' . $ecimgrow['thumbnail'],
				'S_TITLE' => $ecimgrow['title'],
				'S_COUNTER' => $ecimgrow['counter'],
				'S_TIME' => date("d.m.Y H:i", $ecimgrow['time']),
				'S_ECARDS_NR' => $ecNRcount,
				'S_ECARDS_AR' => $ecARcount,
				'S_ECARD_VERSION' => $ecard_config['version'],
				'U_ECARD_ACTION' => append_sid("admin_ecard_img.$phpEx?iid=$ecdelimgid"))
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
	}
}
else
{
	if ($HTTP_POST_VARS['mode'] == 'edit')
	{
		$ecimgid = intval($HTTP_GET_VARS['iid']);
		if (strlen($HTTP_POST_VARS['image_title']) > $ecard_config['title_max_len'])
		{
			message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . sprintf($lang_ec['Title_too_long'], $ecard_config['title_max_len']));
		}
		$ecimgtitle = str_replace("\'", "''", htmlspecialchars(trim($HTTP_POST_VARS['image_title'])));
		if (empty($ecimgtitle))
		{
			message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . $lang_ec['Missed_pic_title']);
		}
		$catid = intval($HTTP_POST_VARS['target']);

		if ($catid != 0)
		{
			$sql = "SELECT *
				FROM " . ECARD_CATEGORIES_TABLE . "
				WHERE id = " . $catid;
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
			}
			if( $db->sql_numrows($result) == 0 )
			{
				message_die(GENERAL_ERROR, 'The requested category does not exist');
			}
		}

		$sql = "UPDATE " . ECARD_IMAGES_TABLE . "
			SET title = '$ecimgtitle', categorie_id = $catid 
			WHERE image_id = " . $ecimgid;
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update this eCard image', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang_ec['Image_updated'] . "<br /><br />" . sprintf($lang_ec['Click_return_ecard_image'], "<a href=\"" . append_sid("admin_ecard_img.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	elseif ($HTTP_POST_VARS['mode'] == 'delete')
	{
		$ecimgdelid = intval($HTTP_GET_VARS['iid']);

		$sql = "DELETE FROM " . ECARD_IMAGES_TABLE . "
			WHERE image_id = " . $ecimgdelid;
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not delete this Image', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang_ec['Image_deleted'] . "<br /><br />" . sprintf($lang_ec['Click_return_ecard_image'], "<a href=\"" . append_sid("admin_ecard_img.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

?>