<?php
/***************************************************************************
 *                           admin/admin_ecard_cat.php
 *                          ------------------------------
 *   Version              : Version 0.2.0 - 09.01.2006
 *   copyright            : (C) 2005-2006 M.W.
 *   URL                  : http://phpbb.mwegner.de/
 *
 ***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['eCard']['ec_Categories'] = $filename;
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = '../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_ecard.' . $phpEx);
include($phpbb_root_path . 'includes/ecard_config.'.$phpEx);

if (!isset($HTTP_POST_VARS['mode']))
{
	if (!isset($HTTP_GET_VARS['action']))
	{
		$template->set_filenames(array(
			'body' => 'admin/ecard_cat_body.tpl')
		);

		$template->assign_vars(array(
			'L_ECARD_CAT_TITLE' => $lang_ec['Admin_Categories_Title'],
			'L_ECARD_CAT_EXPLAIN' => $lang_ec['Admin_Categories_Explain'],
			'L_CREATE_CATEGORY' => $lang['Create_category'], 
			'L_EDIT' => $lang['Edit'],
			'L_DELETE' => $lang['Delete'],
			'S_ECARD_VERSION' => $ecard_config['version'],
			'U_ECARD_ACTION' => append_sid("admin_ecard_cat.$phpEx"))
		);

		$sql = "SELECT *
			FROM " . ECARD_CATEGORIES_TABLE . "
			ORDER BY categorie ASC";
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
		}
		while ($row = $db->sql_fetchrow($result))
		{
			$eccatrow[] = $row;
		}

		$eccat_count = count($eccatrow);
		if ($eccat_count > 0)
		{
			for ($i=0; $i<$eccat_count; $i++)
			{
				$template->assign_block_vars('eccatrow', array(
					'COLOR' => ($i % 2) ? 'row1' : 'row2',
					'TITLE' => $eccatrow[$i]['categorie'],
					'U_EDIT_ACTION' => append_sid("admin_ecard_cat.$phpEx?action=edit&amp;id=" . $eccatrow[$i]['id']),
					'U_DELETE_ACTION' => append_sid("admin_ecard_cat.$phpEx?action=delete&amp;id=" . $eccatrow[$i]['id'])
					)
				);
			}
		}
		else
		{
			$template->assign_block_vars('switch_no_categories', array()); 
			$template->assign_vars(array(
				'L_NO_CATEGORIES' => $lang_ec['no_categories'])
			);
		}

		$template->pparse('body');

		include('./page_footer_admin.'.$phpEx);
	}
	else
	{
		if ($HTTP_GET_VARS['action'] == 'edit')
		{
			$eccatid = intval($HTTP_GET_VARS['id']);
			$sql = "SELECT *
				FROM " . ECARD_CATEGORIES_TABLE . "
				WHERE id = " . $eccatid;
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
			}
			if( $db->sql_numrows($result) == 0 )
			{
				message_die(GENERAL_ERROR, 'The requested category does not exist');
			}
			$eccatrow = $db->sql_fetchrow($result);

			$template->set_filenames(array(
				'body' => 'admin/ecard_cat_edit_body.tpl')
			);

			$template->assign_vars(array(
				'L_ECARD_CAT_TITLE' => $lang_ec['Admin_Categories_Title'],
				'L_ECARD_CAT_EXPLAIN' => $lang_ec['Admin_Categories_Explain'],
				'L_PANEL_TITLE' => $lang['Edit_Category'],
				'L_CAT_TITLE' => $lang_ec['Category_Title'],
				'S_CAT_TITLE' => $eccatrow['categorie'],
				'S_MODE' => 'edit',
				'S_ECARD_VERSION' => $ecard_config['version'],
				'U_ECARD_ACTION' => append_sid("admin_ecard_cat.$phpEx?eid=$eccatid"))
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		elseif ($HTTP_GET_VARS['action'] == 'delete')
		{
			$ecdelcatid = intval($HTTP_GET_VARS['id']);
			$sql = "SELECT *
				FROM " . ECARD_CATEGORIES_TABLE . "
				ORDER BY categorie ASC";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not query eCard Categories information', '', __LINE__, __FILE__, $sql);
			}

			$ecdelcat_found = FALSE;
			while( $row = $db->sql_fetchrow($result) )
			{
				if ($row['id'] == $ecdelcatid)
				{
					$deletecat = $row;
					$ecdelcat_found = TRUE;
				}
				else
				{
					$eccatrow[] = $row;
				}
			}
			if( $ecdelcat_found == FALSE )
			{
				message_die(GENERAL_ERROR, $lang_ec['Category_not_found']);
			}

			$select_to = '<select name="target"><option value="0">'. $lang_ec['Main_Categorie'] .'</option>';
			$eccatrow_count = count($eccatrow);
			for ($i=0; $i<$eccatrow_count; $i++)
			{
				$select_to .= '<option value="'. $eccatrow[$i]['id'] .'">'. $eccatrow[$i]['categorie'] .'</option>';
			}
			$select_to .= '</select>';

			$template->set_filenames(array(
				'body' => 'admin/ecard_cat_delete_body.tpl')
			);

			$template->assign_vars(array(
				'L_CAT_DELETE' => $lang_ec['Delete_Category'],
				'L_CAT_DELETE_EXPLAIN' => $lang_ec['Delete_Category_Explain'],
				'L_CAT_TITLE' => $lang_ec['Category_Title'],
				'L_MOVE_IMAGES' => $lang['Move_contents'],
				'L_MOVE_DELETE' => $lang['Move_and_Delete'],
				'S_CAT_TITLE' => $deletecat['categorie'],
				'S_MOVE_IMAGES' => $select_to,
				'S_ECARD_VERSION' => $ecard_config['version'],
				'U_ECARD_ACTION' => append_sid("admin_ecard_cat.$phpEx?eid=$ecdelcatid"))
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
	}
}
else
{
	if ($HTTP_POST_VARS['mode'] == 'new')
	{
		if (!isset($HTTP_POST_VARS['cattitle']))
		{
			$template->set_filenames(array(
				'body' => 'admin/ecard_cat_edit_body.tpl')
			);

			$template->assign_vars(array(
				'L_ECARD_CAT_TITLE' => $lang_ec['Admin_Categories_Title'],
				'L_ECARD_CAT_EXPLAIN' => $lang_ec['Admin_Categories_Explain'],
				'L_PANEL_TITLE' => $lang['Create_category'],
				'L_CAT_TITLE' => $lang_ec['Category_Title'],
				'S_MODE' => 'new',
				'S_ECARD_VERSION' => $ecard_config['version'],
				'U_ECARD_ACTION' => append_sid("admin_ecard_cat.$phpEx"))
			);

			$template->pparse('body');

			include('./page_footer_admin.'.$phpEx);
		}
		else
		{
			if (strlen($HTTP_POST_VARS['cattitle']) > $ecard_config['title_max_len'])
			{
				message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . sprintf($lang_ec['Title_too_long'], $ecard_config['title_max_len']));
			}
			$eccattitle = str_replace("\'", "''", htmlspecialchars(trim($HTTP_POST_VARS['cattitle'])));
			if (empty($eccattitle))
			{
				message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . $lang_ec['Missed_cat_title']);
			}
			$sql = "INSERT INTO " . ECARD_CATEGORIES_TABLE . " (categorie) 
				VALUES ('$eccattitle')";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not create new eCard Category', '', __LINE__, __FILE__, $sql);
			}

			$message = $lang_ec['New_category_created'] . "<br /><br />" . sprintf($lang_ec['Click_return_ecard_category'], "<a href=\"" . append_sid("admin_ecard_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

			message_die(GENERAL_MESSAGE, $message);
		}
	}
	elseif ($HTTP_POST_VARS['mode'] == 'edit')
	{
		$eccatid = intval($HTTP_GET_VARS['eid']);
		if (strlen($HTTP_POST_VARS['cattitle']) > $ecard_config['title_max_len'])
		{
			message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . sprintf($lang_ec['Title_too_long'], $ecard_config['title_max_len']));
		}
		$eccattitle = str_replace("\'", "''", htmlspecialchars(trim($HTTP_POST_VARS['cattitle'])));
		if (empty($eccattitle))
		{
			message_die(GENERAL_ERROR, $lang_ec['not_updated'] . '<br /><br />' . $lang_ec['Missed_cat_title']);
		}

		$sql = "UPDATE " . ECARD_CATEGORIES_TABLE . "
			SET categorie = '$eccattitle'
			WHERE id = " . $eccatid;
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update this eCard Category', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang_ec['Category_updated'] . "<br /><br />" . sprintf($lang_ec['Click_return_ecard_category'], "<a href=\"" . append_sid("admin_ecard_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	elseif ($HTTP_POST_VARS['mode'] == 'delete')
	{
		$eccatdelid = intval($HTTP_GET_VARS['eid']);
		$targetcat = intval($HTTP_POST_VARS['target']);

		$sql = "UPDATE " . ECARD_IMAGES_TABLE . "
			SET categorie_id = " . $targetcat . "
			WHERE categorie_id = " . $eccatdelid;
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update this Category content', '', __LINE__, __FILE__, $sql);
		}

		$sql = "DELETE FROM " . ECARD_CATEGORIES_TABLE . "
			WHERE id = " . $eccatdelid;
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not delete this Category', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang_ec['Category_deleted'] . "<br /><br />" . sprintf($lang_ec['Click_return_ecard_category'], "<a href=\"" . append_sid("admin_ecard_cat.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

?>